Hangman
=======

Game Description
----------------
The game of Hangman is pretty well known: an unknown word with a given number of letters is indicated as blanks, and the user guesses letters that might be part of the word, one letter at a time. Letters that occur in the word are filled in at their correct location, and letters that don't appear in the word cause another body part of the hanged man to be drawn. A typical hangman figure would include a head, two arms, a torso, and two legs, for a total of six body parts, although some games use more, allowing for more guesses. If the drawing of the hangman gets completed before the user has guessed the word, they lose the game.

Description of Program
-------------------------
For this game you'll use the `wordlist.txt` provided by the instructor as a source of words for the game. Your program will select a random word from that list, present a series of blank spaces that will start to be filled in as the user guesses letters, and a list of incorrect letters that the user has already tried, along with the drawing of the hangman as the game progresses. The user will continue guessing letters and seeing their progress until they have won or lost the game.

General Outline of Program
-----------------------------
You might consider using the following outline as a guide to structuring your program.

    def display_game_state(correct, missed, word):
        """This shows the blanks in the word, the 
        letters that have been incorrectly guessed,
        and the hangman in its current state.
        """
    
        # insert code here
    
        

    def all_letters_guessed(correct, word):
        """This looks through the list "correct" which
        contains all the letters that have been correctly
        guessed, and compares them with the letters in the
        secret "word". If all the letters in word have
        been found, this function returns True.
        """
        
        # insert code here
        
        
        
        

    def check_letter(letter_guessed, word, correct, missed):
        """This function takes the letter_guessed and compares
        it to the letters in word. If the letter_guessed is found
        in the word, the letter is added to the list "correct",
        otherwise it is added to the list "missed"
        """
        
        # insert code here
        
        
        
        
    def get_secret_word():
        """This function opens up the file wordlist.txt and
        picks a random word from that file, and returns it.
        """
        
        # insert code here
        
        
        
        
        
        
        
        

    def main():
        """This program runs the game by calling the functions
        listed above.
        """
        
        # Insert code here
        
        
        
        
        
        
        

    if  __name__ == "__main__":
        main()


Sample Output
-------------

    Let's play Hangman!
    I'm thinking of a word...
    Enter a letter guess: s
    Sorry, there is no s in the word.
    _ _ _ _ _ _ _ _ _

    Missed:  ['s']

    ----+
        |
        |
        O


    Enter a letter guess: e
    Sorry, there is no e in the word.
    _ _ _ _ _ _ _ _ _

    Missed:  ['s', 'e']

    ----+
        |
        |
        O
        +

    Enter a letter guess: a
    Yes, there is a a in the word!
    _ a _ _ _ a _ _ _

    Missed:  ['s', 'e']

    ----+
        |
        |
        O
        +

    Enter a letter guess: i
    Yes, there is a i in the word!
    _ a _ i _ a _ _ _

    Missed:  ['s', 'e']

    ----+
        |
        |
        O
        +

    Enter a letter guess: o
    Sorry, there is no o in the word.
    _ a _ i _ a _ _ _

    Missed:  ['s', 'e', 'o']

    ----+
        |
        |
        O
      --+

    Enter a letter guess: c
    Yes, there is a c in the word!
    _ a _ i c a _ _ _

    Missed:  ['s', 'e', 'o']

    ----+
        |
        |
        O
      --+

    Enter a letter guess: t
    Sorry, there is no t in the word.
    _ a _ i c a _ _ _

    Missed:  ['s', 'e', 'o', 't']

    ----+
        |
        |
        O
      --+--


    Enter a letter guess: r
    Sorry, there is no r in the word.
    _ a _ i c a _ _ _

    Missed:  ['s', 'e', 'o', 't', 'r']

    ----+
        |
        |
        O
      --+--
        |


    Enter a letter guess: m
    Yes, there is a m in the word!
    m a _ i c a _ _ _

    Missed:  ['s', 'e', 'o', 't', 'r']

    ----+
        |
        |
        O
      --+--
        |


    Enter a letter guess: n
    Sorry, there is no n in the word.
    m a _ i c a _ _ _

    Missed:  ['s', 'e', 'o', 't', 'r', 'n']

    ----+
        |
        |
        O
      --+--
        |
       /

    Enter a letter guess: q
    Sorry, there is no q in the word.
    m a _ i c a _ _ _

    Missed:  ['s', 'e', 'o', 't', 'r', 'n', 'q']

    ----+
        |
        |
        O
      --+--
        |
       / \

    Game Over!
    The word was magically!


    Good game!

