LunarLander
=======

Game Description
----------------
LunarLandar is a solo game in which the player tries to pilot a spacecraft to land safely on the surface of the moon. The "lunar module" has an initial position above the surface of the moon and initial velocities as it is coming in for a landing. With a limited amount of fuel available, the player applies thrusters to slow the descent of the spacecraft so that it gently lands on the surface. Use too much fuel before the spacecraft is down and it will crash! Don't use enough fuel and the spacecraft will be traveling too fast when it land, and it will crash!

Preliminary thinking
--------------------

This is essentially a physics problem: the spacecraft is falling from some height towards the surface of the moon, but we can change its motion by applying thrusters that change its motion.

The problem can actually be written as a text-based game, but it's nice to be able to see the lunar module as it descends towards the surface, and watching it descend gives the player better feedback than watching numbers click by.

You might want to consider coding the physics first, getting the game running, and implementing the graphics at the very end of it all.

Description of Program
----------------------

The lander has an initial horizontal and vertical velocity, and an initial position at some height above the surface. As time passes it accelerates downward, so its position and velocity change. When the user fires a thruster, however, a Force is applied to the mass of the lander, causing it to accelerate. We don't need to make up any Force or mass values--we can just say that the thruster causes an acceleration of some positive value (that we'll make up) as long as the thruster is firing. Different thrusters will produce accelerations in different directions, so we'll need to do the math to figure out how to change the positions and velocities according to the physics equations.

General Outline of Program
--------------------------

"""
lunarlander.py
This program simulates the landing of a lunar module on the surface of the
moon. Don't crash!
"""
    

    def setup():
        global variables # list them here
        # initialize horizontal and vertical positions
        # initialize horizontal and vertical velocities
        # initialize horizontal and vertical accelerations
        # initialize deltaT value
    
    def draw():
        global variables # list them here
        # display state of lander
        # if lander has safely landed, inform user and quit
        # if lander has crashed, inform user and quit
        # if thruster key pressed:
        #    set acceleration to new value
        # else:
        #    set acceleration to usual value
        # calculate new position based on current values and deltaT
        # calculate new velocities based on current values and deltaT    
    
