Mugwumps
=======

Game Description
----------------
On a 10 x 10 grid, four mythical "mugwumps" are hiding. Enter a coordinate where you think one might be -- 0,3 for example -- and you'll get hints as to how far away the four mugwumps are located. Pay attention to these clues -- you only have ten guesses to find all four hidden mugwumps!

Preliminary thinking
--------------------
There are a number of interesting aspects to this program. One way to get started might be just to write a program that hides a single mugwump. The player tries find the location of that mugwump, and the program gives them hints as they go. Getting the board to display is one part of the challenge here.

Once the game works for a single mugwump, it's relatively easy to create a list of four mugwumps and include them all as part of the game.

Description of Program
----------------------
At the beginning of play, the program will "hide" the four mugwumps by creating random coordinates for their positions. The program will then repeatedly ask the user to enter a guess where they think a mugwump might be hiding. The list of mugwump locations is checked, and if they user has guessed a location correctly, the value on the gameboard is changed to indicate that with an "M". If it's a miss, however, the gameboard location is changed to a "*". 

Guessing proceeds until all the mugwumps have been found or until 10 guess have been used up, whichever comes first.

Special Information
-------------------
The program will use a two-dimensional array to keep track of the guesses the user has made, and display the board something like this:

        * * * MUGWUMPS * * *
     9 |. . . . . . . . . .
     8 |. . . . * . . . . .
     7 |. . . . . . * . . .
     6 |. . * . . . . . . .
     5 |. . . . . M . . . .
     4 |* . * . . . . . * .
     3 |. . . * . . . . . .
     2 |. . . . . . . * . .
     1 |. . . . . . . . . .
     0 |* . . . M . . . . M
       +--------------------
        0 1 2 3 4 5 6 7 8 9


General Outline of Program
--------------------------

    def play_mugwumps(mugwumps):
        """This is the important part of the program, where the guessing and hint-
        giving happens.
        """
        
            
    def establish_board():
        """This initializes the board, identifying 4 random locations where the 
        mugwumps are "hiding". Note how we check to make sure that we don't 
        accidentally put two mugwumps in the same location."""
        
    
    def print_board(mugwumps, mugwumps_found, guesses_list):
        """print board, with locations of known mugwumps indicated
        """
        
    def give_instructions():
        
    def say_goodbye():
    
    def main():
        give_instructions()
        play = True
        while(play):
            mugwumps = establish_board()
            play_mugwumps(mugwumps)
            play_again = input("Play again (Y/n)? ")
            if play_again != "" and play_again[0].lower() != "y":
                play = False
        say_goodbye()
    
    if __name__ == "__main__":
        main()

play_mugwumps()
---------------

This is where the gameplay actually happens:

    def play_mugwumps(mugwumps):
        """This is the important part of the program, where the guessing and hint-
        giving happens."""
        
        # set up a guess counter
        # keep a list of mugwump locations identified
        # keep a list of bad guesses
        
        while guess <= 10 and len(mugwumps_found) < 4:
            print_board(mugwumps, mugwumps_found, guesses_list)
            print("Guess #",guess," Where do you think a mugwump might be (x,y)? ",end='')
            x,y = int(input())         # gets user input and stores in x,y
            
            # Print status report for all mugwumps for this location
            for m in range(len(mugwumps)):      # Go through each mugwumps[m]...
                # If we've already found this mugwump, say so and do nothing else!
                if [mugwumps[m][0],mugwumps[m][1]] in mugwumps_found:
                    print("You've already found mugwump #", m+1)
                # If this mugwump[m] is located at the place we guessed, say so
                # and add them to the list of found mugwumps
                elif [mugwumps[m][0],mugwumps[m][1]] == [x,y]: 
                    mugwumps_found.append([x,y])     # found mugwump, add to found list
                    print("You've just found mugwump #", m+1)
                # If this current mugwump[m] is not in our found list, calculate the
                # distance, add this location to the guesses_list, and print out result
                if mugwumps[m] not in mugwumps_found:
                    guesses_list.append([x,y])
                    distance = ((x - mugwumps[m][0])**2 + (y - mugwumps[m][1])**2)**0.5
                    print("The distance to mugwump #",m+1,"is",distance)
            # increment the guess counter
            
             
            # This is the end of the big loop. When we fall out of this loop to the
            # next line, it's either because they've used all their guesses (guess > 10),
            # or they found all the mugwumps (len(mugwumps_found) == 4). So let's print
            # a result for them.
        if guess > 10:
            print("You're all out of guesses!")
        print("You found",len(mugwumps_found),"mugwumps!")
        print("Here's where they were hiding:")
        print_board(mugwumps, mugwumps, guesses_list)
