#!/usr/bin/env python3
"""
The Pizza class simulates a virtual pizza.
You can use this class by including
    import pizza
at the top of your program and using statements like
    p = pizza.Pizza()
    p.addTopping("pepperoni")
    p.slice(8)
    p.eatSlice()
    print(p.getSlices())
in your program.
@author Richard White
@version 2015-12-09
"""

class Pizza:

    def __init__(self):
        """Constructs a new pizza.
        """
        self.slices = 0
        self.toppings = ["tomato sauce","cheese"]

    def slice(self, numOfSlices):
        """Splits the pizza up into the specified
        number of slices.
        """
        self.slices = numOfSlices

    def eatSlice(self,numOfSlices=1):
        """Use to eat slices of pizza. Has a default value
        of 1 that is used if no number is specified.
        """
        self.slices = self.slices - numOfSlices

    def getSlices(self):
        """Returns the number of slices remaining in pizza.
        """
        return self.slices

    def addTopping(self, newTopping):
        """Adds a topping to our pizza.
        """
        self.toppings.append(newTopping)

    def getToppings(self):
        """Gives us a list of all the toppings on the pizza.
        """
        return self.toppings