#!/usr/bin/env python3
"""
python-gmail.py
This Python3 version is based on original post at http://kutuma.blogspot.com/2007/08/sending-emails-via-gmail-with-python.html

This script requires that you log in to your Google account and
enable unsafe operations (like letting a script have access to your
email account). From Google account: My Account > Sign-in & security > Allow less secure apps: ON

For safety, do not use an important Gmail account for this script. 

@author Richard White
@version 2017-04-20
"""

import smtplib
from email.mime.multipart import MIMEMultipart
from email.mime.base import MIMEBase
from email.mime.text import MIMEText

# Change this to your Gmail account that you're sending FROM
gmail_user = "yourgmailaccount@gmail.com" 

# To authenticate use of Gmail account. Note that it's not a 
# good idea to place passwords in plaintext anywhere, and 
# especially not in a script!
gmail_pwd = "yourpassword"      

def mail(to, subject, text):
    msg = MIMEMultipart()

    msg['From'] = gmail_user
    msg['To'] = to
    msg['Subject'] = subject
    msg.attach(MIMEText(text))
    mailServer = smtplib.SMTP("smtp.gmail.com", 587)
    mailServer.ehlo()
    mailServer.starttls()
    mailServer.ehlo()
    mailServer.login(gmail_user, gmail_pwd)
    mailServer.sendmail(gmail_user, to, msg.as_string())
    mailServer.close()

# This function call initiates the function defined above, 
# with the parameters being the intended recipient, the 
# subject line, and the body of the message.
mail("recipient@someISP.com",
    "Your subject line goes here",
    "This is the body of the email.\n\nPut your text in here and it will be delivered via email.")
