#!/usr/bin/env python3
"""
w6_password_checker.py
This program has four functions: the three functions you wrote in 
`w5_character_checker.py` and a new one that you'll write: `legal_password()`.

To be legal, a given password has to have at least 8 letters, at least one
special character, and between 2 and 4 (inclusive) digits. The `legal_password`
takes an expression as a parameter, and then return True if the expression 
is a legal password that meets all the rules, or False if it is not legal.
"""


__author__ = "Your name"
__version__ = "The date"



def legal_password(expression):
    """This function returns True if `expression` is a legal password according
    to the rules given in this assignment.
    Requires the use of the count_letters, count_digits, and count_special_chars
    functions!
    """
    # Replace this line with your code
    

def count_letters(expression):
    """This function takes the String parameter `expression` and counts
    how many letters (A..Z or a..z) occur in that expression.
    """

    alphabet = "abcdefghijklmnopqrstuvwxyz"
    # Replace this line with your code



def count_digits(expression):
    """This function takes the String expression `expression` and counts
    how many digits (0..9) occur in that expression.
    """

    digits = "0123456789"
    # Replace this line with your code


def count_special_chars(expression):
    """This function takes the String expression `expression` and counts
    how many special characters -- !@#$%^&*() -- occur in that expression.
    """

    digits = "!@#$%^&*()"
    # Replace this line with your code



# ========= Tester below. No need to edit code below. ================

def main():
    tests = (("123456", False),
             ("I@mTheBest25", True),
             ("abdfgty8904^^^", False),
             ("password45678@", False)) 
    tests_passed = 0
    tests_total = len(tests)
    for test in tests:
        print("Testing to see if",test[0], " is a legal password...")
        if legal_password(test[0]) == test[1]:
            print("Test passed!")
            if test[1] == True:
                print("The function correctly determined that this IS a legal password!")
            else:
                print("The function correctly determined that this IS NOT a legal password!")
            tests_passed += 1
        else:
            print("Test failed!")
            if test[1] == True:
                print("The function did not identify this as a legal password.")
            else:
                print("The function did not identify this as an illegal password.")

    print("Testing completed.")
    print(tests_passed, "out of",tests_total,"tests passed") 
        
if __name__ == "__main__":
    main()

