#!/usr/bin/env python3
"""
w8_Student.py
This program defines a Student class which can be used to create
Student objects.
"""

__author__ = "Your name"
__version__ = "The date"


class Student(object):
    """Describes a student in terms of his/her/their name (a string),
    grade_level (an integer), and preferred gender_pronouns (a string,
    typically "he/him/his", "she/her/hers", "they/them/theirs", etc.)
    If the gender_pronouns parameter is left blank, the gender_pronouns
    will be identified as None.
    """

    # Replace this line with your code
    def __init__(self, name, grade_level, gender_pronouns=None):
        """This constructor creates a new instance of a Student object.
        """



    def getName(self):
        """Returns the name of the Student.
        """


    def getGrade(self):
        """Returns the grade level of the student.
        """


    def getPronouns(self):
        """Returns the gender pronouns of the student, usually in the
        format "Subject/Object/Possessive." Common examples include
        "he/him/his", "she/her/hers", "they/them/theirs". May have 
        a None value.
        """


    def promote(self):
        """Advances the grade level of the Student by 1.
        """


    def __str__(self):
        """Returns a string version of the object, suitable for printing.
        Requires using the str() method for grade_level and gender_pronouns.
        """
        return "Student[name=" + self.name + \
               ",grade_level=" + str(self.grade_level) + \
               ",gender_pronouns=" + str(self.gender_pronouns) + "]"



# ========= Tester below. No need to edit code below. ================

def main():
    print("Creating three Student objects...",end=' ')
    s1 = Student("Greg",4,"he,him,his")
    s2 = Student("Jean",8,"they,them,theirs")
    s3 = Student("Lizzy",10)
    print("tests passed!")
    print("Checking getName() method...", end=' ')    
    if s1.getName() == "Greg": print("test passed!")
    else: print("test failed.")
    print("Checking promotion() method...", end=' ')    
    s2.promote()
    print("test passed!")
    print("Checking getGrade() method...", end=' ')    
    if s2.getGrade() == 9: print("test passed!")
    else: print("test failed.")
    print("Checking getPronouns() method...", end=' ')    
    if s3.getPronouns() == None: print("test passed!")
    else: print("test failed.")

if __name__ == "__main__":
    main()

